            #GIT_CMT=292b867718e88f21f18ad882d9e33022cb9aa462
%{!?ruby_sitelib: %global ruby_sitelib %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")}
%{!?ruby_sitearch: %global ruby_sitearch %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")}

Name:          	powershell
Version:	6.2.2
Release:    1.0.1.el7
Epoch:		1
Summary:       	PowerShell is an automation and configuration management platform. 
License:       	MIT License 
URL:           	https://github.com/PowerShell/PowerShell
Vendor:		Oracle America, Inc. 
Source: powershell-6.2.2.tar.bz2
BuildRequires:  which curl gcc-c++ cmake make powershell sed yum
BuildRequires:  ruby ruby-devel libicu libunwind groff git glibc-common sudo openssl-libs
Requires:       glibc libicu openssl libunwind uuid zlib libcurl libgcc ncurses-base libstdc++ openssl-libs 
Provides:	libcrypto.so.1.0.0()(64bit)
Provides:	libssl.so.1.0.0()(64bit)	
Patch8:         0008-Support-Oracle-Linux-7.patch 

%define release_tag %(echo %{version} | sed 's/_/-/') 
%define debug_package %{nil}
%define gem_path %(gem environment gemdir)
%define fpm_path %(ls %{gem_path}/gems/fpm*/bin -d)
%define ronn_path %(ls %{gem_path}/gems/ronn*/bin -d)

%description
PowerShell is an automation and configuration management platform.
It consists of a cross-platform command-line shell and associated scripting language.


%prep
%setup
%patch8 -p1

%build
export LANG=en_US.UTF-8
export LC_ALL=$LANG
export PATH=$PATH:%{fpm_path}:%{ronn_path}
git init
git config --global user.name "Livy Ge"
git config --global user.email "livy.ge@oracle.com"
git add --all; git commit -m "initial setup"
git tag v%{version} -a -m "tag v%{version}"
# run localedef in sudo mode
sudo localedef --charmap=UTF-8 --inputfile=en_US $LANG
pwsh -command "
Import-Module ./build.psm1
Import-Module ./tools/packaging/packaging.psm1
Start-PSBootstrap -Package
Start-PSBuild -Crossgen -Clean -PSModuleRestore -Runtime linux-x64 -Configuration Release
Start-PSPackage -Type rpm -SkipReleaseChecks
"

%install
install -m 755 -d $RPM_BUILD_ROOT/opt/microsoft/%{name}/%{release_tag}
cp -Prv tools/packaging/staging/* $RPM_BUILD_ROOT/opt/microsoft/%{name}/%{release_tag}
mkdir -p $RPM_BUILD_ROOT/usr/bin
ln -s /opt/microsoft/%{name}/%{release_tag}/pwsh $RPM_BUILD_ROOT/usr/bin/pwsh
mkdir -p $RPM_BUILD_ROOT/usr/local/share/man/man1
cp assets/pwsh.1.gz $RPM_BUILD_ROOT/usr/local/share/man/man1/pwsh.1.gz

%clean
rm -rf $RPM_BUILD_ROOT
 
%post
#!/bin/sh
if [ ! -f /etc/shells ] ; then
    echo "/usr/bin/pwsh" > /etc/shells
else
    grep -q "^/usr/bin/pwsh$" /etc/shells || echo "/usr/bin/pwsh" >> /etc/shells
fi

%postun
if [ "$1" = 0 ] ; then
    if [ -f /etc/shells ] ; then
        TmpFile=`/bin/mktemp /tmp/.powershellmXXXXXX`
        grep -v '^/usr/bin/pwsh$' /etc/shells > $TmpFile
        cp -f $TmpFile /etc/shells
        rm -f $TmpFile
    fi
fi

%files
%defattr(-,root,root,-)
%dir %attr(0755,root,root) /opt
/opt/microsoft/%{name}/%{release_tag}/*
/usr/bin/pwsh
/usr/local/share/man/man1/pwsh.1.gz

%changelog
* Tue Aug 20 2019 Jingdong Lu <jingdong.lu@oracle.com> - 1:6.2.2-1.0.1.el7
- dynamic set fpm path

* Mon Aug 19 2019 Jingdong Lu <jingdong.lu@oracle.com> 6.2.2-1
- Update to 6.2.2

* Tue Jun 04 2019 Alan Steinberg <alan.steinberg@oracle.com> - 6.2.1-1.0.1.el7 
- OL merge for 6.2.1-1

* Thu Sep 27 2018 Alan Steinberg <alan.steinberg@oracle.com> - 6.1.0-1.0.1.el7 
- OL merge for 6.1.0-1
- PowerShell 6.1.0 requires modifications to Oracle patches [OraBug 28730117]

* Mon Aug 13 2018 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.4-1.0.1.el7 
- OL merge for 6.0.4-1

* Fri Mar 16 2018 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.2-1.0.1.el7 
- OL merge for 6.0.2-1

* Mon Jan 29 2018 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.1-1.0.1.el7 
- OL merge for 6.0.1-1

* Wed Jan 10 2018 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0-1.0.1.el7 
- OL merge for 6.0.0-1

* Fri Dec 15 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_rc.2-1.0.1.el7 
- OL merge for 6.0.0_rc.2

* Tue Nov 21 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_rc-1.0.1.el7 
- OL merge for 6.0.0_rc

* Tue Oct 31 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_beta.9-1.0.1.el7 
- OL merge for 6.0.0_beta.9

* Tue Oct 17 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_beta.8-1.el7 
- OL merge for 6.0.0_beta.8

* Mon Sep 25 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_beta.7-1.el7 
- OL merge for 6.0.0_beta.7

* Tue May 30 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_beta.1-1.el7 
- removed dirty tag from powershell.version
- changed source URL to point to github

* Wed May 24 2017 Alan Steinberg <alan.steinberg@oracle.com> - 6.0.0_beta.1-1.el7 
- converted to build from gzip source
- added second patch to work around workaround for upstream https://github.com/PowerShell/PowerShell/pull/3740

* Thu May 18 2017 Tianyue Lan <tianyue.lan@oracle.com> - 6.0.0_beta.1-1.el7 
- updated patch to handle dotnet-install.sh
- added provides for libcrypto.so.1.0.0 and libssl.so.1.0.0

* Wed May 10 2017 Tianyue Lan <tianyue.lan@oracle.com> - 6.0.0_alpha.17-1.el7 
- initialize it
